export type PubMedRecord = {
    uid: string;
    pubdate: string;
    epubdate: string;
    source: string;
    authors: { name: string; authtype: string; clusterid: string }[];
    lastauthor: string;
    title: string;
    sorttitle: string;
    volume: string;
    issue: string;
    pages: string;
    lang: string[];
    nlmuniqueid: string;
    issn: string;
    essn: string;
    pubtype: string;
    recordstatus: string;
    pubstatus: string;
    articleids: { idtype: string; idtypen: number; value: string }[];
    history: { pubstatus: string; date: string }[];
    references: {
        refsource: string;
        reftype: string;
        pmid: number;
        note: string;
    }[];
    attributes: string[];
    pmcrefcount: number;
    fulljournalname: string;
    elocationid: string;
    doctype: string;
    srccontriblist: any[];
    booktitle: string;
    medium: string;
    edition: string;
    publisherlocation: string;
    publishername: string;
    srcdate: string;
    reportnumber: string;
    availablefromurl: string;
    locationlabel: string;
    doccontriblist: any[];
    docdate: string;
    bookname: string;
    chapter: string;
    sortpubdate: string;
    sortfirstauthor: string;
    vernaculartitle: string;
};
