#!/bin/bash

# Überprüfen, ob ein Parameter übergeben wurde
if [ -z "$1" ]; then
  echo "Fehler: Kein Parameter angegeben. Bitte geben Sie einen Parameter an."
  exit 1
fi

# Holen Sie sich das Verzeichnis, in dem sich das Skript befindet
SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
cd "$SCRIPT_DIR"

echo "Entferne node_modules..."
rm -rf node_modules

echo "Installiere Abhängigkeiten..."
yarn install --frozen-lockfile

echo "Erstelle DLL für die Entwicklung..."
yarn run buildDLL:dev

echo "Erstelle Module..."
yarn run buildModules

export BRANCH_ENV=$1
echo "Setze BRANCH_ENV auf $BRANCH_ENV"

echo "Starte die Anwendung..."
yarn run start
